@echo off
setlocal enabledelayedexpansion

set "continue=1"

:main
@ echo off
color a
cls
echo ***************************************************
echo SendShellMail Ver 1.0 for Batch Xplorer Ver 1.2beta
echo ***************************************************
echo.

REM SendShellMail Ver 1.0 (for Powershell)                                           
REM Copyright(c) 2023 theDUBBER, All Rights Reserved.                                
REM https://thedubber.altervista.org    thedubber@rocketmail.com                     
REM  ---------------------------------------------------------------------------     
REM The program prompts the user to provide some information needed to               
REM sending the email. You are prompted for the name of the SMTP server              
REM ("SMTP Server") and the SMTP port ("SMTP Port") to be used to send the email.    
REM This information are essential to establish a connection with the mail server.   
REM                                                                                  
REM The user is then prompted to enter the sender's email address ("From") e         
REM that of the recipient ("To"). These fields are mandatory, as they are            
REM needed to properly route email from sender to recipient.                         
REM                                                                                  
REM The program continues by asking the user to supply some optional fields.         
REM The "Cc" (carbon copy) field allows you to specify one or more email addresses   
REM separated by commas to send a copy of the email to further recipients.           
REM If the user wants to include a "Cc" field, they can enter it otherwise they can  
REM simply press Enter to skip it.                                                   
REM                                                                                  
REM Subsequently, the user is asked to enter the subject of the email                
REM ("Subject") and the email body text ("Body"). These fields are                   
REM mandatory, as they are the main content of the email.                            
REM                                                                                  
REM Finally, the user has the option to attach a file to the email ("Attachment").   
REM If the user wants to include an attachment, he can provide the path to the       
REM file from attach; otherwise, you can leave the field blank and press Enter to    
REM continue without attachments.                                                    
REM                                                                                  
REM At this point, the script checks if the "Cc" and "Attachment" fields are empty or
REM if they contain values. Depending on the combination, it builds a string of      
REM corresponding PowerShell commands to send the email with or without copy to      
REM carbon and attachments.                                                          
REM                                                                                  
REM Next, the script executes the corresponding PowerShell command string            
REM using the "powershell -Command" command. This launches powershell and invokes    
REM the "Send-MailMessage" module to send the email with the parameters provided     
REM by the user.                                                                     
REM                                                                                  
REM After sending the email, a message "Email sent with                              
REM success!" to confirm that the operation was completed successfully.              
REM                                                                                  
REM Finally, the script gives the user a choice: press Enter to start over           
REM the script and send another email or type "0" and press Enter to exit            
REM from the program. If the user decides to exit, the "continue" variable is        
REM set to 0, and the script terminates. If not, the script returns                  
REM to the ":main" label to start a new iteration of the process                     
REM send email.                                                                      
REM                                                                                  
REM When the user decides to exit the program, a message is displayed                
REM Final REM "The script has completed." and the script terminates permanently.     
REM                                                                                  
REM This program offers a simple and interactive solution for sending emails         
REM via PowerShell, allowing the user to specify all the details                     
REM needed directly from a command prompt window.                                    
                                                                               
REM Start Code:-----------------------------------------------------------------         

@echo off
setlocal enabledelayedexpansion

set "continue=1"

:main
cls
echo SendShellMail Ver 1.0 (for Powershell)
echo Copyright(c) 2023 theDUBBER, All Rights Reserved.
echo https://thedubber.altervista.org    thedubber@rocketmail.com
echo ------------------------------------------------------------
echo.
rem Richiedi i valori tramite input
set /p "SMTPServer=<SMTP Server> "
set /p "SMTPPort=<SMTP Port> "
echo ------------------------------------------------------------
set /p "From=<From> "
set /p "To=<To> "

rem I seguenti campi sono resi facoltativi
set /p "Cc=Cc (optional, press Enter to skip)>"
set /p "Subject=<Subject> "
echo -----------------------------------------Text(in one line)--
set /p "Body=<Text> "
set /p "Attachment=<Attachment (optional, press Enter to skip)> "

rem Controllo se i campi Cc e Attachment sono vuoti e costruisco la stringa dei parametri per PowerShell
if not defined Cc (
    if not defined Attachment (
        goto no_cc_no_attachment
    ) else (
        goto no_cc_with_attachment
    )
) else (
    if not defined Attachment (
        goto with_cc_no_attachment
    ) else (
        goto with_cc_and_attachment
    )
)

:no_cc_no_attachment
powershell -Command "Send-MailMessage -From '%From%' -To '%To%' -Subject '%Subject%' -Body '%Body%' -SmtpServer '%SMTPServer%' -Port %SMTPPort% -UseSsl -Credential (Get-Credential) -DeliveryNotificationOption OnSuccess"
goto email_sent

:no_cc_with_attachment
powershell -Command "Send-MailMessage -From '%From%' -To '%To%' -Subject '%Subject%' -Body '%Body%' -SmtpServer '%SMTPServer%' -Port %SMTPPort% -UseSsl -Credential (Get-Credential) -Attachment '%Attachment%' -DeliveryNotificationOption OnSuccess"
goto email_sent

:with_cc_and_attachment
powershell -Command "Send-MailMessage -From '%From%' -To '%To%' -Subject '%Subject%' -Body '%Body%' -SmtpServer '%SMTPServer%' -Port %SMTPPort% -cc '%Cc%' -UseSsl -Credential (Get-Credential) -Attachment '%Attachment%' -DeliveryNotificationOption OnSuccess"
goto email_sent

:with_cc_no_attachment
powershell -Command "Send-MailMessage -From '%From%' -To '%To%' -Subject '%Subject%' -Body '%Body%' -SmtpServer '%SMTPServer%' -Port %SMTPPort% -cc '%Cc%' -UseSsl -Credential (Get-Credential) -DeliveryNotificationOption OnSuccess"
goto email_sent

:email_sent
echo Email successfully sent!

:choice
echo.
set /p "choice=Press Enter to restart the script, press 0 and Enter to exit. "
if "%choice%"=="0" (
    set "continue=0"
) else (
    goto main
)

if %continue%==0 (
    echo Lo script è stato completato.
    exit /b
)

REM End Code:-------------------------------------------------------------------